//<c>   Copyright 1993-2000 by Gerry J. Danen; all rights reserved.

//<t>   Beep the PC's speaker

#include"gd_tools.h"


#define pgVERS_ "V2.00"
#define pgTITL_ "Beep the Speaker"
#define pgCOPR_ "1993"


//      Makes the PC speaker emit a sound at `frequency' Herz for
//      approximately `duration' milliseconds.

void    sound( short frequency, long duration )
{
    clock_t start;

    duration *= CLK_TCK;
    duration /= 1000;
    frequency = (short) (1193180L / (long) frequency);
    (void) outp ( 0x43, 182 );
    (void) outp ( 0x42, frequency & 0xFF );
    (void) outp ( 0x42, frequency >> 8 );

    start = clock();
    (void) outp ( 0x61, inp ( 0x61 ) | 3 );
    while ( clock() - start < duration ) ;
    (void) outp ( 0x61, inp ( 0x61 ) & 0xFC );
}


void    beep(void)
{
    sound( 1200, 45 );  // was 1000,50
}


void    buzzer(void)
{
    sound( 80, 120 );   // was 50,150
}


void    main( void )
{
    beep();
    buzzer();
    beep();
}
